﻿using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Calendar3
{
    public partial class AJAXCalendar : System.Web.UI.Page
    {
        protected DataSet dsHolidays;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SetToThisMonth();
            }
        }

        protected void SetToThisMonth()
        {
            ddlYear.SelectedValue = DateTime.Today.Year.ToString();
            ddlMonth.SelectedValue = DateTime.Today.Month.ToString();
            EventCalendar.VisibleDate = DateTime.Today;
            FillHolidayDataset();
        }

        protected void ChangeToDropDownMonth()
        {
            EventCalendar.VisibleDate = new DateTime(Convert.ToInt16(ddlYear.SelectedValue), Convert.ToInt16(ddlMonth.SelectedValue), 1);
            FillHolidayDataset();
        }

        protected void FillHolidayDataset()
        {
            DateTime firstDate = new DateTime(EventCalendar.VisibleDate.Year, EventCalendar.VisibleDate.Month, 1);
            DateTime today = EventCalendar.VisibleDate.Date;
            DateTime lastDate = new DateTime(EventCalendar.VisibleDate.Year, EventCalendar.VisibleDate.Month, DateTime.DaysInMonth(EventCalendar.VisibleDate.Year, EventCalendar.VisibleDate.Month));
            dsHolidays = GetCurrentMonthData(firstDate, lastDate);
        }


        protected DataSet GetCurrentMonthData(DateTime firstDate, DateTime lastDate)
        {
            DataSet dsMonth = new DataSet();
            ConnectionStringSettings cs;
            cs = ConfigurationManager.ConnectionStrings["EventManagerConnectionString"];
            string connString = cs.ConnectionString;
            SqlConnection dbConnection = new SqlConnection(connString);
            string query = null;
            query = "SELECT CalendarDate, HolidayName FROM Calendar WHERE CalendarDate >= '" + @firstDate.ToShortDateString() + "' AND CalendarDate <= '" + @lastDate.ToShortDateString() + "'  AND HolidayName IS NOT NULL";
            SqlCommand dbCommand = new SqlCommand(query, dbConnection);
            dbCommand.Parameters.Add(new SqlParameter("@firstDate", firstDate));
            dbCommand.Parameters.Add(new SqlParameter("@lastDate", lastDate));

            SqlDataAdapter Adapter = new SqlDataAdapter(dbCommand);
            try
            {
                Adapter.Fill(dsMonth);
            }
            catch
            {
            }
            return dsMonth;
        }


        protected void EventCalendar_DayRender(object sender, DayRenderEventArgs e)
        {
            DateTime nextDate;
            String HolidayName;
            if (dsHolidays != null)
            {
                foreach (DataRow dr in dsHolidays.Tables[0].Rows)
                {
                    nextDate = (DateTime)dr["CalendarDate"];
                    HolidayName = (String)dr["HolidayName"];
                    if (nextDate == e.Day.Date)
                    {
                        e.Cell.BackColor = System.Drawing.Color.Silver;
                        e.Cell.Controls.Add(new LiteralControl("<span style='font-size:.65em;'><br />" + HolidayName + "</span>"));
                    }
                }
            }
            if (e.Day.Date == (EventCalendar.SelectedDate))
            {
                e.Day.IsSelectable = false;
            }

        }
        protected void EventCalendar_VisibleMonthChanged(object sender, MonthChangedEventArgs e)
        {
            ddlYear.SelectedValue = EventCalendar.VisibleDate.Year.ToString();
            ddlMonth.SelectedValue = EventCalendar.VisibleDate.Month.ToString();

            FillHolidayDataset();
        }

        protected void EventCalendar_SelectionChanged(object sender, EventArgs e)
        {
            FillHolidayDataset();
        }


        protected void ddlYear_SelectedIndexChanged(Object sender, EventArgs e)
        {
            ChangeToDropDownMonth();
        }

        protected void ddlMonth_SelectedIndexChanged(Object sender, EventArgs e)
        {
            ChangeToDropDownMonth();
        }

        protected void btnClear_Click(object sender, EventArgs e)
        {
            SetToThisMonth();
        }

    }
}